#ifndef _IDT_H_
#define _IDT_H_

#include <System/Common/Types.h>

#define KERNEL_CS 0x08
#define INT_ATTR 0x8E
#define IDT_ENTRIES 256

typedef struct __attribute__((packed)) {
	uint16_t limit;
	uint64_t base;
} idtRegister;

typedef struct __attribute__((packed)) {
	uint16_t baseLow;
	uint16_t codeSegmentSelector;
	uint8_t zero;
	uint8_t attributes;
	uint16_t baseMiddle;
	uint32_t baseHigh;
	uint32_t reserved;
} idtGate;

extern idtGate mainIdt[IDT_ENTRIES];
extern idtRegister mainIdtReg;

void setIdt();
void setIdtGate(uint8_t gateNumber, uint64_t handlerAddress);

#endif