#include <System/Cpu/Isr.h>
#include <System/Cpu/Idt.h>
#include <System/Cpu/Ports.h>
#include <System/Drivers/Screen.h>

char *exceptionMessages[] = {
    "Division by Zero",
    "Debug",
    "Non-Maskable Interrupt",
    "Breakpoint",
    "Overflow",
    "Out of Bounds",
    "Invalid Opcode",
    "No Coprocessor",

    "Double Fault",
    "Coprocessor Segment Overrun",
    "Bat TSS",
    "Segment not Present",
    "Stack Fault",
    "General Protection Fault",
    "Page Fault",
    "Unknown Interrupt",

    "Coprocessor Fault",
    "Alignment Check",
    "Reserved",
    "Reserved",
    "Reserved",
    "Reserved",
    "Reserved",

    "Reserved",
    "Reserved",
    "Reserved",
    "Reserved",
    "Reserved",
    "Reserved",
    "Reserved",
    "Reserved"
};

void isrInstall() {
    setIdtGate(0, (uint64_t) isr0);
    setIdtGate(1, (uint64_t) isr1);
    setIdtGate(2, (uint64_t) isr2);
    setIdtGate(3, (uint64_t) isr3);
    setIdtGate(4, (uint64_t) isr4);
    setIdtGate(5, (uint64_t) isr5);
    setIdtGate(6, (uint64_t) isr6);
    setIdtGate(7, (uint64_t) isr7);
    setIdtGate(8, (uint64_t) isr8);
    setIdtGate(9, (uint64_t) isr9);
    setIdtGate(10, (uint64_t) isr10);
    setIdtGate(11, (uint64_t) isr11);
    setIdtGate(12, (uint64_t) isr12);
    setIdtGate(13, (uint64_t) isr13);
    setIdtGate(14, (uint64_t) isr14);
    setIdtGate(15, (uint64_t) isr15);
    setIdtGate(16, (uint64_t) isr16);
    setIdtGate(17, (uint64_t) isr17);
    setIdtGate(18, (uint64_t) isr18);
    setIdtGate(19, (uint64_t) isr19);
    setIdtGate(20, (uint64_t) isr20);
    setIdtGate(21, (uint64_t) isr21);
    setIdtGate(22, (uint64_t) isr22);
    setIdtGate(23, (uint64_t) isr23);
    setIdtGate(24, (uint64_t) isr24);
    setIdtGate(25, (uint64_t) isr25);
    setIdtGate(26, (uint64_t) isr26);
    setIdtGate(27, (uint64_t) isr27);
    setIdtGate(28, (uint64_t) isr28);
    setIdtGate(29, (uint64_t) isr29);
    setIdtGate(30, (uint64_t) isr30);
    setIdtGate(31, (uint64_t) isr31);

    setIdt();

    __asm__ volatile("sti");
}

void isrHandler(registers registers) {
    print("\rReceived Interrupt: ", WHITE, RED);

    const char *message = exceptionMessages[registers.int_no];
    print(message, WHITE, RED);
}
